%if 0%{?rhel} && 0%{?rhel} <= 6
%{!?__python2: %global __python2 /usr/bin/python2}
%{!?python2_sitelib: %global python2_sitelib %(%{__python2} -c "from distutils.sysconfig import get_python_lib; print(get_python_lib())")}
%{!?python2_sitearch: %global python2_sitearch %(%{__python2} -c "from distutils.sysconfig import get_python_lib; print(get_python_lib(1))")}
%endif

%global	release_name kilo
%global	full_release ironic-%{version}


Name:		openstack-ironic
Summary:	OpenStack Baremetal Hypervisor API (ironic)
Version:	2015.1.2
Release:	3%{?dist}
License:	ASL 2.0
Group:		System Environment/Base
URL:		http://www.openstack.org
Source0:	https://launchpad.net/ironic/%{release_name}/%{version}/+download/ironic-%{version}.tar.gz
#Source0:	https://launchpad.net/ironic/juno/2014.2/+download/ironic-2014.2.tar.gz

Source1:	openstack-ironic-api.service
Source2:	openstack-ironic-conductor.service
Source3:	ironic-rootwrap-sudoers
Source4:	ironic-dist.conf

# patches_base=+2
Patch0001: 0001-Revert-change-to-tarball-setup.cfg-due-to-setuptools.patch
Patch0002: 0002-Add-DRAC-BIOS-config-vendor-passthru-API.patch
Patch0003: 0003-DRAC-BIOS-vendor_passthru-enable-rebooting-the-node.patch
Patch0004: 0004-DRAC-support-for-RAID-via-vendor_passthru.patch
Patch0005: 0005-WIP-DRAC-automatic-RAID-configuration.patch
Patch0006: 0006-WIP-DRAC-automatic-BIOS-configuration.patch
Patch0007: 0007-Fix-drac-implementation-of-set_boot_device.patch
Patch0008: 0008-Add-missing-pass_bootloader_install_info-to-DRAC-ven.patch
Patch0009: 0009-Make-task_manager-logging-more-helpful-part-of-bz-12.patch
Patch0010: 0010-Clean-nodes-stuck-in-DEPLOYING-state-when-ir-cond-re.patch
Patch0011: 0011-Allow-updates-when-node-is-on-ERROR-provision-state.patch
Patch0012: 0012-Fix-DRAC-driver-job-completion-detection.patch
Patch0013: 0013-DRAC-fix-set-get-boot-device-for-11g.patch
Patch0014: 0014-Fix-DRAC-BIOS-range-check-on-parameters.patch
Patch0015: 0015-Remove-the-autofree-option-from-boot.ipxe.patch
Patch0016: 0016-Add-pxe_ucs-and-agent_ucs-drivers-to-manage-Cisco-UC.patch
Patch0017: 0017-Fix-iSCSI-iqn-name-RFC-violation.patch
Patch0018: 0018-Prevent-node-delete-based-on-provision-not-power-sta.patch
Patch0019: 0019-Only-take-exclusive-lock-in-sync_power_state-if-node.patch
Patch0020: 0020-Use-standard-locale-when-executing-dd-command.patch
Patch0021: 0021-Use-standard-locale-when-executing-parted-command.patch
Patch0022: 0022-Add-Jenkins-config-for-automated-testing.patch
Patch0023: 0023-Skip-failing-unittests-blocking-gate.patch

BuildArch:	noarch
BuildRequires:	python-setuptools
BuildRequires:	python2-devel
BuildRequires:	python-pbr
BuildRequires:	openssl-devel
BuildRequires:	libxml2-devel
BuildRequires:	libxslt-devel
BuildRequires:	gmp-devel
BuildRequires:	python-sphinx
BuildRequires:	systemd


%prep
%setup -q -n %{full_release}

%patch0001 -p1
%patch0002 -p1
%patch0003 -p1
%patch0004 -p1
%patch0005 -p1
%patch0006 -p1
%patch0007 -p1
%patch0008 -p1
%patch0009 -p1
%patch0010 -p1
%patch0011 -p1
%patch0012 -p1
%patch0013 -p1
%patch0014 -p1
%patch0015 -p1
%patch0016 -p1
%patch0017 -p1
%patch0018 -p1
%patch0019 -p1
%patch0020 -p1
%patch0021 -p1
%patch0022 -p1
%patch0023 -p1

rm requirements.txt test-requirements.txt

%build
%{__python2} setup.py build

%install
%{__python2} setup.py install -O1 --skip-build --root=%{buildroot}


# install systemd scripts
mkdir -p %{buildroot}%{_unitdir}
install -p -D -m 644 %{SOURCE1} %{buildroot}%{_unitdir}
install -p -D -m 644 %{SOURCE2} %{buildroot}%{_unitdir}

# install sudoers file
mkdir -p %{buildroot}%{_sysconfdir}/sudoers.d
install -p -D -m 440 %{SOURCE3} %{buildroot}%{_sysconfdir}/sudoers.d/ironic

mkdir -p %{buildroot}%{_sharedstatedir}/ironic/
mkdir -p %{buildroot}%{_sysconfdir}/ironic/rootwrap.d

#Populate the conf dir
install -p -D -m 640 etc/ironic/ironic.conf.sample %{buildroot}/%{_sysconfdir}/ironic/ironic.conf
install -p -D -m 640 etc/ironic/policy.json %{buildroot}/%{_sysconfdir}/ironic/policy.json
install -p -D -m 640 etc/ironic/rootwrap.conf %{buildroot}/%{_sysconfdir}/ironic/rootwrap.conf
install -p -D -m 640 etc/ironic/rootwrap.d/* %{buildroot}/%{_sysconfdir}/ironic/rootwrap.d/

# Log directory
install -d -m 750 %{buildroot}/%{_localstatedir}/log/ironic

# Install distribution config
install -p -D -m 640 %{SOURCE4} %{buildroot}/%{_datadir}/ironic/ironic-dist.conf

# Delete tests
rm -fr %{buildroot}%{python_sitelib}/ironic/tests

%description
Ironic provides an API for management and provisioning of physical machines

%package common
Summary: Ironic common
Group: System Environment/Base

Requires:	ipmitool
Requires:	python-eventlet
Requires:	python-greenlet
Requires:	python-iso8601
Requires:	python-posix_ipc
Requires:	python-jsonpatch
Requires:	python-keystonemiddleware
Requires:	python-kombu
Requires:	python-anyjson
Requires:	python-lockfile
Requires:	python-lxml
Requires:	python-migrate
Requires:	python-mock
Requires:	python-netaddr
Requires:	python-oslo-config
Requires:	python-oslo-db
Requires:	python-oslo-i18n
Requires:	python-oslo-rootwrap
Requires:	python-oslo-utils
Requires:	python-paramiko
Requires:	python-pecan
Requires:	python-retrying
Requires:	python-six
Requires:	python-stevedore
Requires:	python-webob
Requires:	python-websockify
Requires:	python-wsme
Requires:	pycrypto
Requires:	python-sqlalchemy
Requires:	python-neutronclient
Requires:	python-glanceclient
Requires:	python-keystoneclient
Requires:	python-swiftclient
Requires:	python-jinja2
Requires:	python-pyghmi
Requires:	python-alembic
Requires:	pysendfile

Requires(pre):	shadow-utils

%description common
Components common to all OpenStack Ironic services


%files common
%doc README.rst LICENSE
%{_bindir}/ironic-dbsync
%{_bindir}/ironic-rootwrap
%{python_sitelib}/ironic*
%{_sysconfdir}/sudoers.d/ironic
%config(noreplace) %attr(-,root,ironic) %{_sysconfdir}/ironic
%attr(-,ironic,ironic) %{_sharedstatedir}/ironic
%attr(-, root, ironic) %{_datadir}/ironic/ironic-dist.conf
%dir %attr(0750, ironic, root) %{_localstatedir}/log/ironic

%pre common
getent group ironic >/dev/null || groupadd -r ironic
getent passwd ironic >/dev/null || \
    useradd -r -g ironic -d %{_sharedstatedir}/ironic -s /sbin/nologin \
-c "OpenStack Ironic Daemons" ironic
exit 0

%package api
Summary: The Ironic API
Group: System Environment/Base

Requires: %{name}-common = %{version}-%{release}

Requires(post): systemd
Requires(preun): systemd
Requires(postun): systemd

%description api
Ironic API for management and provisioning of physical machines


%files api
%doc LICENSE
%{_bindir}/ironic-api
%{_unitdir}/openstack-ironic-api.service

%post api
%systemd_post openstack-ironic-api.service

%preun api
%systemd_preun openstack-ironic-api.service

%postun api
%systemd_postun_with_restart openstack-ironic-api.service

%package conductor
Summary: The Ironic Conductor
Group: System Environment/Base

Requires: %{name}-common = %{version}-%{release}

Requires(post): systemd
Requires(preun): systemd
Requires(postun): systemd

%description conductor
Ironic Conductor for management and provisioning of physical machines


%files conductor
%doc LICENSE
%{_bindir}/ironic-conductor
%{_unitdir}/openstack-ironic-conductor.service

%post conductor
%systemd_post openstack-ironic-conductor.service

%preun conductor
%systemd_preun openstack-ironic-conductor.service

%postun conductor
%systemd_postun_with_restart openstack-ironic-conductor.service



%changelog
* Fri Mar 04 2016 Mike Burns <mburns@redhat.com> 2015.1.2-3
- Use standard locale when executing 'parted' command rhbz#1269688
- Use standard locale when executing 'dd' command rhbz#1269688
- Only take exclusive lock in sync_power_state if node is updated rhbz#1241424
- Prevent node delete based on provision, not power, state rhbz#1269505

* Mon Nov 09 2015 Mike Burns <mburns@redhat.com> 2015.1.2-2
- Fix: iSCSI iqn name RFC violation rhbz#1272553

* Fri Nov 06 2015 Mike Burns <mburns@redhat.com> 2015.1.2-1
- Update to 2015.1.2

* Wed Oct 14 2015 Mike Burns <mburns@redhat.com> 2015.1.1-5
- remove unit tests from rpm rhbz#1271681

* Fri Sep 04 2015 Mike Burns <mburns@redhat.com> 2015.1.1-4
- Add pxe_ucs and agent_ucs drivers to manage Cisco UCS servers

* Fri Sep 04 2015 John Trowbridge <trown@redhat.com> 2015.1.1-3
- Add pxe_ucs and agent_ucs drivers to manage Cisco UCS servers

* Fri Sep 04 2015 John Trowbridge <trown@redhat.com> 2015.1.1-2
- Remove the --autofree option from boot.ipxe

* Thu Sep 03 2015 Mike Burns <mburns@redhat.com> 2015.1.1-1
- Update to upstream 2015.1.1

* Tue Jul 07 2015 Mike Burns <mburns@redhat.com> 2015.1.0-9
- Fix DRAC BIOS range check on parameters rhbz#1238753
- DRAC: fix set/get boot device for 11g rhbz#1230142
- Fix DRAC driver job completion detection rhbz#1231327
- Clean nodes stuck in DEPLOYING state when ir-cond restarts rhbz#1230163
- Allow updates when node is on ERROR provision state rhbz#1230163

* Mon Jun 29 2015 Mike Burns <mburns@redhat.com> 2015.1.0-8
- Make task_manager logging more helpful (part of bz #1233452)

* Fri Jun 19 2015 James Slagle <jslagle@redhat.com> 2015.1.0-7
- Add missing ironic-dist.conf

* Fri Jun 19 2015 Mike Burns <mburns@redhat.com> 2015.1.0-6
- Add missing pass_bootloader_install_info to DRAC vendor_passthru rhbz#1231331

* Mon Jun 15 2015 James Slagle <jslagle@redhat.com> 2015.1.0-5
- Package ironic-dist.conf and configure ironic log files

* Thu Jun 04 2015 Mike Burns <mburns@redhat.com> 2015.1.0-4
- Update to upstream 2015.1.0

* Tue Jun 02 2015 Mike Burns <mburns@redhat.com> 2015.1.0-3
- Fix chainloading iPXE (undionly.kpxe)

* Fri May 08 2015 Mike Burns <mburns@redhat.com> 2015.1.0-2
- [WIP] DRAC: automatic BIOS configuration
- [WIP] DRAC: automatic RAID configuration

* Fri May 08 2015 Mike Burns <mburns@redhat.com> 2015.1.0-1
- Update to upstream 2015.1.0

* Mon Jan 05 2015 James Slagle <jslagle@redhat.com> 2014.2-3
- Remove runtime pbr requirement from version.py

* Thu Oct 23 2014 Angus Thomas <athomas@redhat.com> - 2014.2-2
- Rebased to 2014.2 GA release

* Fri Oct 17 2014 Angus Thomas <athomas@redhat.com> - 2014.2-1
- Rebased to 2014.2 GA release

* Tue Oct 14 2014 Angus Thomas <athomas@redhat.com> - 2014.2-0.3.rc2
- Added requirement for ipmitool

* Mon Oct 13 2014 Angus Thomas <athomas@redhat.com> - 2014.2.rc2-1
- Rebased to 2014.2.rc2

* Thu Oct 9 2014 Angus Thomas <athomas@redhat.com> - 2014.2.rc1-2
- Added sudoers file for rootwrap (bz #1149189)
- Removed the autodiscovery patch

* Mon Oct 6 2014 Angus Thomas <athomas@redhat.com> - 2014.2.rc1-1
- Updated Requires
- Added autodiscovery patch

* Thu Apr 17 2014 Angus Thomas <athomas@redhat.com> - 2014.1-rc2.1
- License file in each package

* Wed Apr 9 2014 Angus Thomas <athomas@redhat.com> - 2014.1-rc1.2
- License file in each package

* Mon Apr 7 2014 Angus Thomas <athomas@redhat.com> - 2014.1-rc1.1
- Rebuilt with -rc1 tarball
- Rebased patches
- Added dependency on python-alembic

* Thu Mar 27 2014 Angus Thomas <athomas@redhat.com> - 2014.1-b2.5
- Split into multiple packages

* Fri Feb 28 2014 Angus Thomas <athomas@redhat.com> - 2014.1-b2.4
- Restored BuildRequires: python-pbr

* Thu Feb 27 2014 Angus Thomas <athomas@redhat.com> - 2014.1-b2.3
- Added dependency on python-pyghmi
- Patch to remove pbr build dependency
- Fixed python2-devel build dependency
- Added noreplace to config files
- Added  unitdir macro for systemd service file installation
- Added scripts to manage systemd services
- Removed unnecessary Requires & BuildRequires


* Mon Feb 24 2014 Angus Thomas <athomas@redhat.com> - 2014.1-b2.2
- Removed /var/log/ironic from package
- Replaced hardcoded file paths with macros
- Added LICENSE and README.rst docs

* Fri Feb 21 2014 Angus Thomas <athomas@redhat.com> - 2014.1-b2.1
- Initial package build

